diff --git a/src/mainboard/asrock/e350m1/romstage.c b/src/mainboard/asrock/e350m1/romstage.c
index 2913c08..89129cf 100644
--- a/src/mainboard/asrock/e350m1/romstage.c
+++ b/src/mainboard/asrock/e350m1/romstage.c
@@ -45,6 +45,23 @@ void cache_as_ram_main(unsigned long bist, unsigned long cpu_init_detectedx)
 {
 	u32 val;
 
+	u32 puf_i;
+	unsigned char puf_result[128];
+	for (puf_i = 0; puf_i < 128; ++puf_i) {
+		puf_result[puf_i] = 0xca;
+	}
+	asm(
+		"movupd %%xmm0, 0(%0);"
+		"movupd %%xmm1, 16(%0);"
+		"movupd %%xmm2, 32(%0);"
+		"movupd %%xmm3, 48(%0);"
+		"movupd %%xmm4, 64(%0);"
+		"movupd %%xmm5, 80(%0);"
+		"movupd %%xmm6, 96(%0);"
+		"movupd %%xmm7, 112(%0);"
+		::"r" (puf_result)
+	);
+
 	/*
 	 * All cores: allow caching of flash chip code and data
 	 * (there are no cache-as-ram reliability concerns with family 14h)
@@ -74,6 +91,14 @@ void cache_as_ram_main(unsigned long bist, unsigned long cpu_init_detectedx)
 	printk(BIOS_DEBUG, "cpu_init_detectedx = %08lx \n", cpu_init_detectedx);
 
 	post_code(0x35);
+
+	for (puf_i = 0; puf_i < 128; ++puf_i) {
+		printk(BIOS_DEBUG, "%02x ", puf_result[puf_i]);
+		if (puf_i % 16 == 15) {
+			printk(BIOS_DEBUG, "\n");
+		}
+	}
+
 	printk(BIOS_DEBUG, "agesawrapper_amdinitmmio ");
 	val = agesawrapper_amdinitmmio();
 	if (val)
